-- C:\CIRCUIT\PROTOTYPE\XDN001\CFG_TOP\USB_ARBITER_WAVE.VHW
-- VHDL Test Bench created by
-- HDL Bencher 2.01
-- Tue Apr 02 14:45:11 2002
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT USB_ARBITER
		PORT (
			CLK : in  std_logic;
			RST : in  std_logic;
			RXF_N : in  std_logic;
			RD_N : out  std_logic;
			USB_DATA : in  std_logic_vector (7 DOWNTO 0);
			BUS_BUSY : out  std_logic;
			TG_READY : in  std_logic;
			TG_DO : out  std_logic_vector (7 DOWNTO 0);
			TG_RD : out  std_logic
		);
	END COMPONENT;

	SIGNAL CLK : std_logic;
	SIGNAL RST : std_logic;
	SIGNAL RXF_N : std_logic;
	SIGNAL RD_N : std_logic;
	SIGNAL USB_DATA : std_logic_vector (7 DOWNTO 0);
	SIGNAL BUS_BUSY : std_logic;
	SIGNAL TG_READY : std_logic;
	SIGNAL TG_DO : std_logic_vector (7 DOWNTO 0);
	SIGNAL TG_RD : std_logic;

BEGIN
	UUT : USB_ARBITER
	PORT MAP (
		CLK => CLK,
		RST => RST,
		RXF_N => RXF_N,
		RD_N => RD_N,
		USB_DATA => USB_DATA,
		BUS_BUSY => BUS_BUSY,
		TG_READY => TG_READY,
		TG_DO => TG_DO,
		TG_RD => TG_RD
	);

	PROCESS -- clock process
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 1 ns;
		CLK <= transport '1';
		WAIT FOR 1 ns;
		WAIT FOR 2 ns;
		CLK <= transport '0';
		WAIT FOR 2 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_RD_N(
			next_RD_N : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (RD_N /= next_RD_N) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns RD_N="));
				write(TX_LOC, RD_N);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_RD_N);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_BUS_BUSY(
			next_BUS_BUSY : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (BUS_BUSY /= next_BUS_BUSY) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns BUS_BUSY="));
				write(TX_LOC, BUS_BUSY);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_BUS_BUSY);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_TG_DO(
			next_TG_DO : std_logic_vector (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (TG_DO /= next_TG_DO) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns TG_DO="));
				write(TX_LOC, TG_DO);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_TG_DO);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_TG_RD(
			next_TG_RD : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (TG_RD /= next_TG_RD) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns TG_RD="));
				write(TX_LOC, TG_RD);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_TG_RD);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		RST <= transport '1';
		RXF_N <= transport '0';
		USB_DATA <= transport std_logic_vector'("11111111"); --FF
		TG_READY <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6 ns
		RST <= transport '0';
		USB_DATA <= transport std_logic_vector'("11111110"); --FE
		-- --------------------
		WAIT FOR 6 ns; -- Time=12 ns
		USB_DATA <= transport std_logic_vector'("11111101"); --FD
		-- --------------------
		WAIT FOR 6 ns; -- Time=18 ns
		USB_DATA <= transport std_logic_vector'("11111100"); --FC
		-- --------------------
		WAIT FOR 6 ns; -- Time=24 ns
		USB_DATA <= transport std_logic_vector'("11111011"); --FB
		TG_READY <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=30 ns
		USB_DATA <= transport std_logic_vector'("11111010"); --FA
		-- --------------------
		WAIT FOR 6 ns; -- Time=36 ns
		USB_DATA <= transport std_logic_vector'("11111001"); --F9
		-- --------------------
		WAIT FOR 6 ns; -- Time=42 ns
		USB_DATA <= transport std_logic_vector'("11111000"); --F8
		-- --------------------
		WAIT FOR 6 ns; -- Time=48 ns
		USB_DATA <= transport std_logic_vector'("11110111"); --F7
		TG_READY <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=54 ns
		USB_DATA <= transport std_logic_vector'("11110110"); --F6
		-- --------------------
		WAIT FOR 6 ns; -- Time=60 ns
		USB_DATA <= transport std_logic_vector'("11110101"); --F5
		-- --------------------
		WAIT FOR 6 ns; -- Time=66 ns
		USB_DATA <= transport std_logic_vector'("11110100"); --F4
		TG_READY <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=72 ns
		USB_DATA <= transport std_logic_vector'("11110011"); --F3
		-- --------------------
		WAIT FOR 6 ns; -- Time=78 ns
		USB_DATA <= transport std_logic_vector'("11110010"); --F2
		-- --------------------
		WAIT FOR 6 ns; -- Time=84 ns
		USB_DATA <= transport std_logic_vector'("11110001"); --F1
		-- --------------------
		WAIT FOR 6 ns; -- Time=90 ns
		USB_DATA <= transport std_logic_vector'("11110000"); --F0
		-- --------------------
		WAIT FOR 6 ns; -- Time=96 ns
		USB_DATA <= transport std_logic_vector'("11101111"); --EF
		-- --------------------
		WAIT FOR 6 ns; -- Time=102 ns
		USB_DATA <= transport std_logic_vector'("11101110"); --EE
		-- --------------------
		WAIT FOR 6 ns; -- Time=108 ns
		USB_DATA <= transport std_logic_vector'("11101101"); --ED
		-- --------------------
		WAIT FOR 6 ns; -- Time=114 ns
		USB_DATA <= transport std_logic_vector'("11101100"); --EC
		TG_READY <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=120 ns
		USB_DATA <= transport std_logic_vector'("11101011"); --EB
		-- --------------------
		WAIT FOR 6 ns; -- Time=126 ns
		USB_DATA <= transport std_logic_vector'("11101010"); --EA
		-- --------------------
		WAIT FOR 6 ns; -- Time=132 ns
		USB_DATA <= transport std_logic_vector'("11101001"); --E9
		-- --------------------
		WAIT FOR 6 ns; -- Time=138 ns
		USB_DATA <= transport std_logic_vector'("11101000"); --E8
		-- --------------------
		WAIT FOR 6 ns; -- Time=144 ns
		USB_DATA <= transport std_logic_vector'("11100111"); --E7
		-- --------------------
		WAIT FOR 6 ns; -- Time=150 ns
		USB_DATA <= transport std_logic_vector'("11100110"); --E6
		-- --------------------
		WAIT FOR 6 ns; -- Time=156 ns
		USB_DATA <= transport std_logic_vector'("11100101"); --E5
		-- --------------------
		WAIT FOR 6 ns; -- Time=162 ns
		USB_DATA <= transport std_logic_vector'("11100100"); --E4
		-- --------------------
		WAIT FOR 6 ns; -- Time=168 ns
		USB_DATA <= transport std_logic_vector'("11100011"); --E3
		-- --------------------
		WAIT FOR 6 ns; -- Time=174 ns
		USB_DATA <= transport std_logic_vector'("11100010"); --E2
		-- --------------------
		WAIT FOR 6 ns; -- Time=180 ns
		USB_DATA <= transport std_logic_vector'("11100001"); --E1
		-- --------------------
		WAIT FOR 6 ns; -- Time=186 ns
		USB_DATA <= transport std_logic_vector'("11100000"); --E0
		-- --------------------
		WAIT FOR 6 ns; -- Time=192 ns
		USB_DATA <= transport std_logic_vector'("11011111"); --DF
		-- --------------------
		WAIT FOR 6 ns; -- Time=198 ns
		USB_DATA <= transport std_logic_vector'("11011110"); --DE
		-- --------------------
		WAIT FOR 6 ns; -- Time=204 ns
		USB_DATA <= transport std_logic_vector'("11011101"); --DD
		-- --------------------
		WAIT FOR 6 ns; -- Time=210 ns
		USB_DATA <= transport std_logic_vector'("11011100"); --DC
		-- --------------------
		WAIT FOR 6 ns; -- Time=216 ns
		USB_DATA <= transport std_logic_vector'("11011011"); --DB
		-- --------------------
		WAIT FOR 6 ns; -- Time=222 ns
		USB_DATA <= transport std_logic_vector'("11011010"); --DA
		-- --------------------
		WAIT FOR 6 ns; -- Time=228 ns
		USB_DATA <= transport std_logic_vector'("11011001"); --D9
		-- --------------------
		WAIT FOR 6 ns; -- Time=234 ns
		USB_DATA <= transport std_logic_vector'("11011000"); --D8
		-- --------------------
		WAIT FOR 6 ns; -- Time=240 ns
		USB_DATA <= transport std_logic_vector'("11010111"); --D7
		-- --------------------
		WAIT FOR 6 ns; -- Time=246 ns
		USB_DATA <= transport std_logic_vector'("11010110"); --D6
		-- --------------------
		WAIT FOR 6 ns; -- Time=252 ns
		USB_DATA <= transport std_logic_vector'("11010101"); --D5
		-- --------------------
		WAIT FOR 6 ns; -- Time=258 ns
		USB_DATA <= transport std_logic_vector'("11010100"); --D4
		-- --------------------
		WAIT FOR 6 ns; -- Time=264 ns
		USB_DATA <= transport std_logic_vector'("11010011"); --D3
		-- --------------------
		WAIT FOR 6 ns; -- Time=270 ns
		USB_DATA <= transport std_logic_vector'("11010010"); --D2
		-- --------------------
		WAIT FOR 6 ns; -- Time=276 ns
		USB_DATA <= transport std_logic_vector'("11010001"); --D1
		-- --------------------
		WAIT FOR 6 ns; -- Time=282 ns
		USB_DATA <= transport std_logic_vector'("11010000"); --D0
		-- --------------------
		WAIT FOR 6 ns; -- Time=288 ns
		USB_DATA <= transport std_logic_vector'("11001111"); --CF
		-- --------------------
		WAIT FOR 6 ns; -- Time=294 ns
		USB_DATA <= transport std_logic_vector'("11001110"); --CE
		-- --------------------
		WAIT FOR 6 ns; -- Time=300 ns
		USB_DATA <= transport std_logic_vector'("11001101"); --CD
		-- --------------------
		WAIT FOR 6 ns; -- Time=306 ns
		USB_DATA <= transport std_logic_vector'("11001100"); --CC
		-- --------------------
		WAIT FOR 6 ns; -- Time=312 ns
		USB_DATA <= transport std_logic_vector'("11001011"); --CB
		-- --------------------
		WAIT FOR 6 ns; -- Time=318 ns
		USB_DATA <= transport std_logic_vector'("11001010"); --CA
		-- --------------------
		WAIT FOR 6 ns; -- Time=324 ns
		USB_DATA <= transport std_logic_vector'("11001001"); --C9
		-- --------------------
		WAIT FOR 6 ns; -- Time=330 ns
		USB_DATA <= transport std_logic_vector'("11001000"); --C8
		-- --------------------
		WAIT FOR 6 ns; -- Time=336 ns
		USB_DATA <= transport std_logic_vector'("11000111"); --C7
		-- --------------------
		WAIT FOR 6 ns; -- Time=342 ns
		USB_DATA <= transport std_logic_vector'("11000110"); --C6
		-- --------------------
		WAIT FOR 6 ns; -- Time=348 ns
		USB_DATA <= transport std_logic_vector'("11000101"); --C5
		-- --------------------
		WAIT FOR 6 ns; -- Time=354 ns
		USB_DATA <= transport std_logic_vector'("11000100"); --C4
		-- --------------------
		WAIT FOR 6 ns; -- Time=360 ns
		USB_DATA <= transport std_logic_vector'("11000011"); --C3
		-- --------------------
		WAIT FOR 6 ns; -- Time=366 ns
		USB_DATA <= transport std_logic_vector'("11000010"); --C2
		-- --------------------
		WAIT FOR 6 ns; -- Time=372 ns
		USB_DATA <= transport std_logic_vector'("11000001"); --C1
		-- --------------------
		WAIT FOR 6 ns; -- Time=378 ns
		USB_DATA <= transport std_logic_vector'("11000000"); --C0
		-- --------------------
		WAIT FOR 6 ns; -- Time=384 ns
		USB_DATA <= transport std_logic_vector'("10111111"); --BF
		-- --------------------
		WAIT FOR 6 ns; -- Time=390 ns
		USB_DATA <= transport std_logic_vector'("10111110"); --BE
		-- --------------------
		WAIT FOR 6 ns; -- Time=396 ns
		USB_DATA <= transport std_logic_vector'("10111101"); --BD
		-- --------------------
		WAIT FOR 6 ns; -- Time=402 ns
		USB_DATA <= transport std_logic_vector'("10111100"); --BC
		-- --------------------
		WAIT FOR 6 ns; -- Time=408 ns
		USB_DATA <= transport std_logic_vector'("10111011"); --BB
		-- --------------------
		WAIT FOR 6 ns; -- Time=414 ns
		USB_DATA <= transport std_logic_vector'("10111010"); --BA
		-- --------------------
		WAIT FOR 6 ns; -- Time=420 ns
		USB_DATA <= transport std_logic_vector'("10111001"); --B9
		-- --------------------
		WAIT FOR 6 ns; -- Time=426 ns
		USB_DATA <= transport std_logic_vector'("10111000"); --B8
		-- --------------------
		WAIT FOR 6 ns; -- Time=432 ns
		USB_DATA <= transport std_logic_vector'("10110111"); --B7
		-- --------------------
		WAIT FOR 6 ns; -- Time=438 ns
		USB_DATA <= transport std_logic_vector'("10110110"); --B6
		-- --------------------
		WAIT FOR 6 ns; -- Time=444 ns
		USB_DATA <= transport std_logic_vector'("10110101"); --B5
		-- --------------------
		WAIT FOR 6 ns; -- Time=450 ns
		USB_DATA <= transport std_logic_vector'("10110100"); --B4
		-- --------------------
		WAIT FOR 6 ns; -- Time=456 ns
		USB_DATA <= transport std_logic_vector'("10110011"); --B3
		-- --------------------
		WAIT FOR 6 ns; -- Time=462 ns
		USB_DATA <= transport std_logic_vector'("10110010"); --B2
		-- --------------------
		WAIT FOR 6 ns; -- Time=468 ns
		USB_DATA <= transport std_logic_vector'("10110001"); --B1
		-- --------------------
		WAIT FOR 6 ns; -- Time=474 ns
		USB_DATA <= transport std_logic_vector'("10110000"); --B0
		-- --------------------
		WAIT FOR 6 ns; -- Time=480 ns
		USB_DATA <= transport std_logic_vector'("10101111"); --AF
		-- --------------------
		WAIT FOR 6 ns; -- Time=486 ns
		USB_DATA <= transport std_logic_vector'("10101110"); --AE
		-- --------------------
		WAIT FOR 6 ns; -- Time=492 ns
		USB_DATA <= transport std_logic_vector'("10101101"); --AD
		-- --------------------
		WAIT FOR 6 ns; -- Time=498 ns
		USB_DATA <= transport std_logic_vector'("10101100"); --AC
		-- --------------------
		WAIT FOR 6 ns; -- Time=504 ns
		USB_DATA <= transport std_logic_vector'("10101011"); --AB
		-- --------------------
		WAIT FOR 6 ns; -- Time=510 ns
		USB_DATA <= transport std_logic_vector'("10101010"); --AA
		-- --------------------
		WAIT FOR 6 ns; -- Time=516 ns
		USB_DATA <= transport std_logic_vector'("10101001"); --A9
		-- --------------------
		WAIT FOR 6 ns; -- Time=522 ns
		USB_DATA <= transport std_logic_vector'("10101000"); --A8
		-- --------------------
		WAIT FOR 6 ns; -- Time=528 ns
		USB_DATA <= transport std_logic_vector'("10100111"); --A7
		-- --------------------
		WAIT FOR 6 ns; -- Time=534 ns
		USB_DATA <= transport std_logic_vector'("10100110"); --A6
		-- --------------------
		WAIT FOR 6 ns; -- Time=540 ns
		USB_DATA <= transport std_logic_vector'("10100101"); --A5
		-- --------------------
		WAIT FOR 6 ns; -- Time=546 ns
		USB_DATA <= transport std_logic_vector'("10100100"); --A4
		-- --------------------
		WAIT FOR 6 ns; -- Time=552 ns
		USB_DATA <= transport std_logic_vector'("10100011"); --A3
		-- --------------------
		WAIT FOR 6 ns; -- Time=558 ns
		USB_DATA <= transport std_logic_vector'("10100010"); --A2
		-- --------------------
		WAIT FOR 6 ns; -- Time=564 ns
		USB_DATA <= transport std_logic_vector'("10100001"); --A1
		-- --------------------
		WAIT FOR 6 ns; -- Time=570 ns
		USB_DATA <= transport std_logic_vector'("10100000"); --A0
		-- --------------------
		WAIT FOR 6 ns; -- Time=576 ns
		USB_DATA <= transport std_logic_vector'("10011111"); --9F
		-- --------------------
		WAIT FOR 6 ns; -- Time=582 ns
		USB_DATA <= transport std_logic_vector'("10011110"); --9E
		-- --------------------
		WAIT FOR 6 ns; -- Time=588 ns
		USB_DATA <= transport std_logic_vector'("10011101"); --9D
		-- --------------------
		WAIT FOR 6 ns; -- Time=594 ns
		USB_DATA <= transport std_logic_vector'("10011100"); --9C
		-- --------------------
		WAIT FOR 598 ns; -- Time=1192 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION USB_ARBITER_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END USB_ARBITER_cfg;
